"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

exports.default = function (_ref) {
	var t = _ref.types;

	function hasSpread(node) {
		var _iteratorNormalCompletion = true;
		var _didIteratorError = false;
		var _iteratorError = undefined;

		try {
			for (var _iterator = node.properties[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
				var prop = _step.value;

				if (t.isSpreadProperty(prop)) {
					return true;
				}
			}
		} catch (err) {
			_didIteratorError = true;
			_iteratorError = err;
		} finally {
			try {
				if (!_iteratorNormalCompletion && _iterator.return) {
					_iterator.return();
				}
			} finally {
				if (_didIteratorError) {
					throw _iteratorError;
				}
			}
		}

		return false;
	}

	return {
		inherits: require("babel-plugin-syntax-object-rest-spread"),

		visitor: {
			RestElement: function RestElement(path) {
				console.log(path);
			},
			ObjectExpression: function ObjectExpression(path, file) {
				if (!hasSpread(path.node)) return;
				var generated = [];
				var vars = {};

				var _arr = ['L', 'I', 'SOURCE', 'KEYS', 'KEY', 'RESULT'];
				for (var _i = 0; _i < _arr.length; _i++) {
					var varName = _arr[_i];
					vars[varName] = path.scope.generateUidIdentifier(varName.toLowerCase());
				}

				generated.push(buildBegin(vars));

				var _iteratorNormalCompletion2 = true;
				var _didIteratorError2 = false;
				var _iteratorError2 = undefined;

				try {
					for (var _iterator2 = path.node.properties[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
						var prop = _step2.value;

						if (t.isSpreadProperty(prop)) {
							generated.push(buildFor(Object.assign(vars, {
								OBJECT: prop.argument
							})));
						} else {
							// TODO how to add semicolon?
							generated.push(t.assignmentExpression('=', t.memberExpression(vars.RESULT, prop.key), prop.value));
						}
					}
				} catch (err) {
					_didIteratorError2 = true;
					_iteratorError2 = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion2 && _iterator2.return) {
							_iterator2.return();
						}
					} finally {
						if (_didIteratorError2) {
							throw _iteratorError2;
						}
					}
				}

				var myPath = path;

				while (path.scope.path != myPath.parentPath) {
					myPath = myPath.parentPath;
				}

				myPath.insertBefore(generated);

				path.replaceWith(vars.RESULT);
			}
		}
	};
};

require("better-log/install");

var _babelTemplate = require("babel-template");

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buildBegin = (0, _babelTemplate2.default)("\n\tvar KEYS, L, I, SOURCE, KEY, RESULT = {};\n");
var buildFor = (0, _babelTemplate2.default)("\n\tfor(\n\t\tSOURCE = OBJECT,\n\t\tKEYS = Object.keys(SOURCE),\n\t\tL = KEYS.length,\n\t\tI = 0;\n\n\t\tI < L;\n\n\t\tI++\n\t) {\n\t\tKEY = KEYS[I];\n\t\tRESULT[KEY] = SOURCE[KEY];\n\t}\n");